import numpy as np
import random
import math
import time
import matplotlib.pyplot as plt

def check4link(v1,v2):
  #print("checking v1 "+str(v1)+", v2= "+str(v2))
  for k in range(len(E[0])):  # over columns
    if( (E[0][k]==v1 and E[1][k]==v2) or (E[0][k]==v2 and E[1][k]==v1)):
      #print("True")
      return True
  #print("False")
  return False

def printField(E,N):
  # rows(i) 0,2,4,... are vertex rows
  # row 1,3,5,.. are link rows
  for r in range(2*N-1):
    i = int(r/2)
    # cols 0,2,... are vertex columns
    # cols 1,3,... are link columns
    for c in range(2*N-1):
      j = int(c/2)
      if( r%2==0 ): #vertex row
        if( c%2==0):
          print("o",end="")
        else:  #check if an edge betwn vertices ...
          v1 = i*N+j; v2 = v1+1
          #print(\
#"process r= "+str(r)+" c= "+str(c)+" v1= "+str(v1)+" v2="+str(v2))
          if( check4link(v1,v2) ):
            print("-",end="")
          else:
            print(" ",end="")
      else:    #link row
        if( c%2==0):
          v1 = i*N+j; v2 = v1+N;
          #print(\
#"process r= "+str(r)+" c= "+str(c)+" v1= "+str(v1)+" v2="+str(v2))
          if( check4link(v1,v2)):
            print("|",end="")
          else:
            print(" ",end="")
        else:  # space betwn columns in non-nodal row
            print(" ",end="")
    #end c
    print("")

def run(E):
 ## to be written ##

### main ###
nTrials = 990000;

#   Initialize the first two rows of E[x][y] to the given graph,
# here a 3x3 grid of vertices; the vertices:   0 1 2
# are indexed top to bottom, left to right:    3 4 5 etc
# y indexes the edges 0,1,...,11:
#   two in the top row between horizontal vertices 0,1 and 1,2,
#   three in the 2nd row between vertical vertices 0,3, 1,4, 2,5 etc
#
# x indexes the ends of the edge, 0 for the left or top edge, 1 for
# the right or bottom edge,
# e.g. E[0][0]=0, E[1][0]=1 means edge 0 is a horizontal edge
#   the left end of edge 0 is vertex 0, the right end is vertex 1
# e.g. E[0][2]=0, E[1][2]=3 means edge 2 is a vertical edge
#   the top end of edge 2 is vertxx 0, the bottom end is vertex 3.

E = np.zeros([3, 12], dtype=int)
E[0][0]=0; E[1][0]=1; E[0][1]=1; E[1][1]=2;
E[0][2]=0; E[1][2]=3; E[0][3]=1; E[1][3]=4; E[0][4]=2; E[1][4]=5;
E[0][5]=3; E[1][5]=4; E[0][6]=4; E[1][6]=5;
E[0][7]=3; E[1][7]=6; E[0][8]=4; E[1][8]=7; E[0][9]=5; E[1][9]=8;
E[0][10]=6; E[1][10]=7; E[0][11]=7; E[1][11]=8;
printField(E,3)

s3 = run(E)
print("number of matchings of size k = 1,2,...: "+str(s3));

E = np.zeros([3, 24], dtype=int)
E[0][0]=0; E[1][0]=1; E[0][1]=1; E[1][1]=2; E[0][2]=2; E[1][2]=3;
E[0][3]=0; E[1][3]=4; E[0][4]=1; E[1][4]=5; E[0][5]=2; E[1][5]=6;
E[0][6]=3; E[1][6]=7; E[0][7]=4; E[1][7]=5; E[0][8]=5; E[1][8]=6;
E[0][9]=6; E[1][9]=7; E[0][10]=4; E[1][10]=8; E[0][11]=5; E[1][11]=9;
E[0][12]=6; E[1][12]=10; E[0][13]=7; E[1][13]=11; E[0][14]=8; E[1][14]=9;
E[0][15]=9; E[1][15]=10; E[0][16]=10; E[1][16]=11;
E[0][17]=8; E[1][17]=12; E[0][18]=9; E[1][18]=13;
E[0][19]=10; E[1][19]=14; E[0][20]=11; E[1][20]=15;
E[0][21]=12; E[1][21]=13; E[0][22]=13; E[1][22]=14;
E[0][23]=14; E[1][23]=15;
printField(E,4)

s4 = run(E)
print("number of matchings of size k = 1,2,...: "+str(s4));

E = np.zeros([3, 40], dtype=int)
E[0][0]=0; E[1][0]=1; E[0][1]=1; E[1][1]=2; E[0][2]=2; E[1][2]=3;
E[0][3]=3; E[1][3]=4;
E[0][4]=0; E[1][4]=5; E[0][5]=1; E[1][5]=6; E[0][6]=2; E[1][6]=7;
E[0][7]=3; E[1][7]=8; E[0][8]=4; E[1][8]=9;

E[0][9]=5; E[1][9]=6; E[0][10]=6; E[1][10]=7; E[0][11]=7; E[1][11]=8;
E[0][12]=8; E[1][12]=9;
E[0][13]=5; E[1][13]=10; E[0][14]=6; E[1][14]=11; E[0][15]=7; E[1][15]=12;
E[0][16]=8; E[1][16]=13; E[0][17]=9; E[1][17]=14;

E[0][18]=10; E[1][18]=11; E[0][19]=11; E[1][19]=12; E[0][20]=12; E[1][20]=13;
E[0][21]=13; E[1][21]=14;
E[0][22]=10; E[1][22]=15; E[0][23]=11; E[1][23]=16; E[0][24]=12; E[1][24]=17;
E[0][25]=13; E[1][25]=18; E[0][26]=14; E[1][26]=19;

E[0][27]=15; E[1][27]=16; E[0][28]=16; E[1][28]=17; E[0][29]=17; E[1][29]=18;
E[0][30]=18; E[1][30]=19;
E[0][31]=15; E[1][31]=20; E[0][32]=16; E[1][32]=21; E[0][33]=17; E[1][33]=22;
E[0][34]=18; E[1][34]=23; E[0][35]=19; E[1][35]=24;

E[0][36]=20; E[1][36]=21; E[0][37]=21; E[1][37]=22; E[0][38]=22; E[1][38]=23;
E[0][39]=23; E[1][39]=24;
printField(E,5)

s5 = run(E)
print("number of matchings of size k = 1,2,...: "+str(s5));


plt.plot([3,4,5], [s3[2]*12/s3[1],s4[2]*24/s4[1],s5[2]*40/s5[1]])
plt.xlabel('Nodal Array Size')
plt.ylabel("Number of dimers out of "+str(nTrials))
plt.title("Comparison of size 2 matchings")
plt.show()

plt.plot([3,4,5], [s3[3]*12/s3[1],s4[3]*24/s4[1],s5[3]*40/s5[1]])
plt.xlabel('Nodal Array Size')
plt.ylabel("Number of dimers out of "+str(nTrials))
plt.title("Comparison of size 3 matchings")
plt.show()

